-- we need some nice oo
Object = {}
function Object:new(o)
	o = o or {}
	setmetatable(o, self)
	local m = getmetatable(self)
	self.__index = self
	self.__call = m.__call
	self.super = m.__index and m.__index.init
	return o
end
setmetatable(Object, { __call = function(self, ...)
	local o = self:new()
	if o.init then o:init(...) end
	return o
end })

-- Incrementar y decrementar valores
function incw(val, max)
 if val==max then return 1 else return val+1 end
end

function decw(val, max)
 if val==1 then return max else return val-1 end
end

function roundDec(val, decimal)
  if (decimal) then
    return math.floor( (val * 10^decimal) + 0.5) / (10^decimal)
  else
    return math.floor(val+0.5)
  end
end

-------------------
-- VECTOR FUNCTIONS

pi2 = math.pi*2.0

function vector(length, angle)
 return rotate(0, -length, angle)
end

function rotate(x,y,a)
 return 
  x*math.cos(a)-y*math.sin(a),
  x*math.sin(a)+y*math.cos(a)
end

function angle(x,y)
 local r = math.pi - math.atan2(x,y)
 
 return r
end

function angle2(fromx,fromy, tox, toy)
 return angle(tox-fromx, toy-fromy)
end


function angleDir(from, to)
 local diff = to-from
 -- avoid rounding errors that will prevent settling
 if math.abs(diff) < 0.00001 then return 0 end 
 if diff > math.pi then 
   return -1 
 elseif diff < -math.pi then
   return 1 
 else 
   return diff>0 and 1 or -1
 end
end

function vecLen(x,y)
  return math.sqrt(x^2 + y^2)
end

function angleAdd(a, d)
 a=a+d
 -- ensure angle is in 0..2pi range
 if a<0 then 
   a=a+pi2
 elseif a>=pi2 then 
   a=a-pi2
 end
 return a
end

function distance(a,b)
  return vecLen(a.x - b.x,a.y - b.y)
end

function pointInRect(p,r)
 return
  p.x>=r.x and p.x<r.x+r.w and
  p.y>=r.y and p.y<r.y+r.h
end
------------------------------------------

function drawLine(x,y,a, length, color)
  local x1,y1 = vector(length,a)
  --love.graphics.line(x,y,x+x1,y+y1, color)
  love.graphics.line(x,y,x+x1,y+y1)
end

-------------------------------------------

function flr(a)                          return math.floor(a)           end
function rou(x)                          return x + 0.5 - (x + 0.5) % 1 end
function ins(tbl,e) table.insert(tbl,e); return e                       end
function rpad(s, l, c)
 local r = s .. string.rep(c or ' ', l - #s)
 return r, r ~= s
end
-------------------------------------------
--`spr(id x y colorkey=-1 scale=1 flip=0 rotate=0 w=1 h=1)`
function spr (id, x, y)
	love.graphics.rectangle("fill", x,y, 10,10)
end

function spr2 ( x, y,angle)
	love.graphics.draw(imageFilecar,x,y,angle,1,1,8,11)
	--love.graphics.draw(imageFilecar,x,y,angle)
end

function pp(text, x, y)
	love.graphics.print(text, x+1, y+1) 
	love.graphics.print(text, x, y)
end

function bPrint(text, x,y,color,size, center, borderColor)
 local xx
 if center then
   --local w = love.graphics.print(text, 0, -50, color, true, size)
   --local w = love.graphics.print(text, 0, -50)
   --xx=x-w/2
   local w = love.graphics.getWidth( )
   love.graphics.print(text, 0, -50)
   xx=x-w/2
   xx=100
 else
   xx=x
 end
 if borderColor>-1 then
  for ax=-1,1 do
   for ay=-1,1 do
    --love.graphics.print(text,xx+ax,y+ay,borderColor,true,size)
	love.graphics.print(text,xx+ax,y+ay)
   end
  end
 end
 --love.graphics.print(text,xx,y,color,true,size)
 love.graphics.print(text,xx,y)

end
